std::swap(std::thread)(3)

NAME
std::swap(std::thread) - std::swap(std::thread)

Synopsis
   void swap( std::thread &lhs, std::thread &rhs ) noexcept; (since C++11)
   Overloads the std::swap algorithm for std::thread. Exchanges the state of lhs with
   that of rhs. Effectively calls lhs.swap(rhs).

Parameters
   lhs, rhs - threads whose states to swap

Return value
   (none)

Example
// Run this code
 #include <iostream>
 #include <thread>
 #include <chrono>
 void foo()
 {
     std::this_thread::sleep_for(std::chrono::seconds(1));
 }
 void bar()
 {
     std::this_thread::sleep_for(std::chrono::seconds(1));
 }
 int main()
 {
     using std::swap;
     std::thread t1(foo);
     std::thread t2(bar);
     std::cout << "thread 1 id: " << t1.get_id() << '\n'
               << "thread 2 id: " << t2.get_id() << '\n';
     swap(t1, t2);
     std::cout << "after std::swap(t1, t2):" << '\n'
               << "thread 1 id: " << t1.get_id() << '\n'
               << "thread 2 id: " << t2.get_id() << '\n';
     t1.swap(t2);
     std::cout << "after t1.swap(t2):" << '\n'
               << "thread 1 id: " << t1.get_id() << '\n'
               << "thread 2 id: " << t2.get_id() << '\n';
     t1.join();
     t2.join();
 }

Possible output:
 thread 1 id: 1892
 thread 2 id: 2584
 after std::swap(t1, t2):
 thread 1 id: 2584
 thread 2 id: 1892
 after t1.swap(t2):
 thread 1 id: 1892
 thread 2 id: 2584

See also
   swap swaps two thread objects
        (public member function)